## sc-e84d756c0b398e437020d58e15b89abfae64f69f.tar.bz2

=== Makefile ===
# Makefile $Revision: 7.16 $
#
# 1) Select the proper EXDIR (path), MANDIR, MANEXT, LIBDIR, SIGVOID,
#	REGEX, DFLT_PAGER, and FMOD. Most of the other things aren't
#	normally changed (see the comments with each)
# 2) Select the proper machine/compiler/OS section of code
#	for MS-DOS look for the pattern 'MS-DOS'
# 3) make install
# 4) If you have the command 'file' that uses /etc/magic add the line:
#	38	string		Spreadsheet	sc file


# Specify the name of the program.
# All documentation and installation keys on this value.
# 
name=sc
NAME=SC

# The base directory where everything should be installed.  If you're
# packaging this with an O/S, for example, you'll probably want to change
# this to /usr.  Otherwise, /usr/local is probably more appropriate, unless
# you're replacing the vendor-supplied version.
prefix=/usr

# This is where the install step puts it.
EXDIR=${prefix}/bin

# This is where the man page goes.
MANDIR=${prefix}/man/man1
MANEXT=1
MANMODE=644

# This is where the library file (tutorial) goes.
#LIBDIR=/usr/local/share/$(name) # reno
LIBDIR=${prefix}/share/doc/$(name)
LIBRARY=-DLIBDIR=\"${LIBDIR}\"

# Set SIMPLE for lex.c if you don't want arrow keys or lex.c blows up
#SIMPLE=-DSIMPLE
SIMPLE=

# Set BROKENCURSES if your curses has the nl/nonl bug
# if it does and you don't set BROKENCURSES, the display will
# be staggered across the screen. Also try IDLOKBAD below.
#BROKENCURSES=-DBROKENCURSES
BROKENCURSES=

# Set USELOCALE to enable country-dependent display of decimal points,
# local character recognition in words, and local @date() format.
#USELOCALE=
USELOCALE=-DUSELOCALE

# Set DOBACKUPS if you would like a backup copy of a source file on a save
#DOBACKUPS=
DOBACKUPS=-DDOBACKUPS

# Set SIGVOID if signal routines are type void.
# use: SIGVOID=-DSIGVOID for:
#	System 5.3, SunOS 4.X, VMS, BSD4.4 (reno), and ANSI C Compliant systems
# use: SIGVOID=		for:
#  BSD systems (excluding reno, BSD4.4), and the UNIXPC 'cc'
#SIGVOID=
SIGVOID=-DSIGVOID

# Set IEEE_MATH if you need setsticky() calls in your signal handlers
#
#IEEE_MATH=-DIEEE_MATH
IEEE_MATH=

# The -ffloat-store compiler option is necessary for compiling interp.c to
# prevent spurious "Still changing after x iterations" errors, intermittent
# problems with the @round function, comparisons failing when they shouldn't,
# and potentially other similar problems due to FPU registers having greater
# precision than doubles in memory.  This is known to be necessary for GCC
# on x86 processors/FPUs, and probably others.
FLOAT_STORE=-ffloat-store

# Set RINT=-DRINT if you do not have rint() in math.h
# Set RINT=	on/with (they have rint):
#	SunOS 4.0.3c compiler
#	BSD4.4 (reno)
#RINT=-DRINT
RINT=

# If your system supports POSIX.2 regular expressions, REGEX should be
# set to -DREGCOMP.  Otherwise, set REGEX to -DREGCMP if you have the
# regcmp/regex regular expression routines (most System V based systems
# do) or to -DRE_COMP if you have the re_comp/re_exec regular expression
# routines (most BSD based systems do).  If your system has no support for
# regular expressions, leave REGEX unset.
#REGEX=
#REGEX=-DREGCMP
#REGEX=-DRE_COMP
REGEX=-DREGCOMP

# This is the name of a pager like "more".
# "pg" may be appropriate for SYSV.
#DFLT_PAGER=-DDFLT_PAGER=\"more\"	# generic && reno
DFLT_PAGER=-DDFLT_PAGER=\"less\"

# This is the name of the history file.  If undefined, the history will
# not be saved.
HISTORY_FILE=-DHISTORY_FILE=\"~/.sc_history\"

# this is the name to save back ups in
SAVE=-DSAVENAME=\"$(NAME).SAVE\"

# path to crypt, do not define if you don't have crypt
# most systems
#CRYPT=-DCRYPT_PATH=\"/bin/crypt\"
# BSD
# CRYPT=-DCRYPT_PATH=\"/usr/bin/crypt\"
# other people?
#CRYPT=-DCRYPT_PATH=\"/usr/local/bin/crypt\"

# If you get errors about fmod being undefined when you try to
# compile, then define NO_FMOD (most likely BSD4.3 and Mt Xinu).
#FMOD=-DNO_FMOD
FMOD=

# If your system doesn't have notimeout() in curses define NONOTIMEOUT
#NO_NOTIMEOUT=-DNONOTIMEOUT
NO_NOTIMEOUT=

# flags for lint
LINTFLAGS=-abchxv

# Format of quick reference guide generated by $(name)qref
# Leave undefined for normal text output.
#QREF_FMT=
QREF_FMT=-DTROFF

# *** SPECIAL NOTES ***
# For ULTRIX: define the BSD4.2 section and SIGVOID above
#	tdw@cl.cam.ac.uk tested on Ultrix 3.1C-0
# HP-UX 7.0: Do NOT use -O
#	(known broken, try sc's boolean operators if you wish)
#
# **** SYSV curses bugs... ****
# Try setting IDLOKBAD to fix (with an empty spreadsheet):
#	a) Redrawing the bottom half of the screen when you
#		move between row 9 <-> 10
#	b) the highlighted row labels being trash when you
#		move between row 9 <-> 10
#	c) On an xterm on Esix Rev. D+ from eating lines
#		 -goto (or move) a few lines (or more) past the bottom
#		 of the screen, goto (or move) to the top line on the
#		 screen, move upward and the current line is deleted, the
#		 others move up even when they should not, check by
#		 noticing the rows become 2, 3, 40, 41, 42... (etc).
#	Known systems/terminfos w/ curses problems:
#	{Esix Rev. D+, AT&T SysV3.2.1}:at386-m,xterm, HP-UX7.0:(not sure)
#IDLOKISBAD=-DIDLOKBAD
IDLOKISBAD=

# If you don't have idlok() in your curses define NOIDLOK
#NO_IDLOK=-DNOIDLOK
NO_IDLOK=

# If moving right off the screen causes the screen to not redraw
# properly, define RIGHT_CBUG to get around a curses problem on some
# boxes, this forces screen redraws when going right off the screen
#RIGHTBUG=-DRIGHT_CBUG
RIGHTBUG=

# IF you have problems w/ your yacc try bison, Berkeley yacc, or
# some other yacc. Some systems don't allow you to
# increase the number of terminals (mostly AT&T), SCO's does though.
# YACC=yacc
# NOTE: Do not use with bison 1.16! Get a new version....
YACC=bison -y

# MS-DOS needs y_tab instead of the normal y.tab
#YTAB=y_tab
YTAB=y.tab

# Command to use to make temporary copies of some source files.
#LN=ln -s
#LN=cp
LN=ln

#### SYSTEM DEFINES ####

#########################################
# Use this for system AIX V3.1
#CFLAGS= -O -DSYSV2 -DCHTYPE=int -DNLS
#LDFLAGS=
#LIB=-lm -lPW -lcurses

#########################################
# Use this for system V.2 (includes: HP-UX 7.05, UNIXPC)
#CFLAGS= -O -DSYSV2 
#LDFLAGS=
#LIB=-lm -lPW -lcurses
# with gcc on a Sequent also use:
#CC=att gcc
#CFLAGS=  -DSYSV2 -g -pipe -traditional

#########################################
# Use this for system V.3
#CFLAGS=  -DSYSV3 -O
#LDFLAGS= -s
#CFLAGS=  -DSYSV3 -g
#LDFLAGS= -g
#LIB=-lm -lncurses -lfl
# with gcc also use:
#CC=gcc
#CFLAGS=  -DSYSV3 -O -pipe
# debugging bison (bison 1.16 is broken)
#CFLAGS=  -DSYSV3 -g -pipe -traditional
#YACC=bison -y -v -t -l

#########################################
# Use this for system V.4
#CFLAGS=  -DSYSV4 -DSYSV3 -O
#LDFLAGS= -s
#LIB=-lm -lcurses -lgen
# with gcc also use:
#CC=gcc
#CFLAGS=  -DSYSV3 -O -pipe

#########################################
# Microport
#CFLAGS= -DSYSV2 -O -DUPORT -Ml
#LDFLAGS=-Ml
#LIB=-lm -lcurses -lPW

#########################################
# Use this for BSD 4.2
#CFLAGS= -O -DBSD42
#LDFLAGS=
#LIB=-lm -lcurses -ltermcap
# with gcc also use:
#CC=gcc

#########################################
# Use this for Sequent boxes
#CC=atscc
#CFLAGS=-O -DBSD42
#LDFLAGS= 
#LIB=-lm -lcurses  -ltermcap
#PSCLIB=-lseq
# with gcc also use:
#CC=gcc
#CFLAGS= -O -DBSD42 -pipe

#########################################
# Use this for BSD 4.3
#CFLAGS= -O -DBSD43	#-O or -g
#LDFLAGS=	# -lg might help if -g used in CFLAGS
#LIB=-lm -lcurses -ltermcap

#########################################
# Use this for SunOS 4.X if you have the System V package installed.
# This will link with the System V curses which is preferable to the
# BSD curses (especially helps scrolling on slow (9600bps or less)
# serial lines).
#
# Be sure to define SIGVOID and REGEX (to -DRE_COMP) above.
# 
#CC=/usr/5bin/cc
#CFLAGS= -O -DSYSV3 
#LDFLAGS=
#LIB=-lm -lcurses 

#########################################
# Use this for system III (XENIX)
#CFLAGS= -O -DSYSIII
#LDFLAGS= -i
#LIB=-lm -lcurses -ltermcap

#########################################
# Use this for XENIX Version 2.3
#CFLAGS= -O -DSYSIII -DXENIX2_3
#LDFLAGS= -i
#LIB=-lm -lcurses -ltermcap

#########################################
# Use this for VENIX
#CFLAGS= -DVENIX -DBSD42 -DV7
#LDFLAGS= -z -i 
#LIB=-lm -lcurses -ltermcap

#########################################
# For SCO Unix V rel. 3.2.0
#       -compile using rcc, cc does not cope with gram.c
#       -edit /usr/include/curses.h, rcc does not understand #error
#       -link: make CC=cc, rcc's loader gets unresolved __cclass, __range
#               (rather strange,?)
#CC=rcc
#CC=cc
#CC=gcc -fstrength-reduce
#SIGVOID=-DSIGVOID
#CFLAGS= -O -DSYSV3
#LDFLAGS=
#LIB=-lm -lcurses -ltinfo -lPW
#YACC=yacc -Sm10000

#########################################
# Use this for SCO Unix 3.2.2 and ODT 1.1
#CC=cc
#CFLAGS= -O -DSYSV3
#LDFLAGS=
#LIB=-lm -lcurses -lPW -lmalloc -lc_s
#YACC=yacc -Sm10000

#########################################
# Use this for MS-DOS, Microsoft C 5.1 and NDMAKE
#CC=cl
#CFLAGS= -AL -O -Fo$*.o
#LDFLAGS=/noi /st:0x4000
#LIB=lcurses
#YACC=bison -y
#
#.SUFFIXES : .o .c
#.c.o:
#	$(CC) $(CFLAGS) -c $*.c

#########################################
# Use this for MS-DOS with DJGPP
# REGEX should also be undefined (see above) unless a separate REGEX library
# is installed (gdb includes one, but may result in file conflicts with
# existing DJGPP files).
#CC=gcc
# Only use -Wall for testing, since it produces warnings that are of no
# real effect on the reliability of the program, but may concern some
# people who don't understand them.
#CFLAGS=-DSYSV3 -O2 -Wall -UMSDOS
#CFLAGS=-DSYSV3 -O2 -UMSDOS
#LIB=-lm -lpdcurses

#########################################
# Use this for Linux
CC=gcc
# Only use -Wall for testing, since it produces warnings that are of no
# real effect on the reliability of the program, but may concern some
# people who don't understand them.
#CFLAGS=-DSYSV3 -O2 -Wall -pipe
CFLAGS=-DSYSV3 -O2 -pipe -g
LIB=-lm -lncurses

# All of the source files
SRC=Makefile abbrev.c cmds.c color.c crypt.c eres.sed frame.c format.c gram.y \
	help.c interp.c lex.c pipe.c psc.c range.c sc.c sc.h screen.c sort.c \
	sres.sed version.c vi.c vmtbl.c xmalloc.c

# The objects
OBJS=abbrev.o cmds.o color.o crypt.o format.o frame.o gram.o help.o interp.o \
	lex.o pipe.o range.o sc.o screen.o sort.o version.o vi.o vmtbl.o \
	xmalloc.o

# The documents in the Archive
DOCS=CHANGES README sc.doc psc.doc tutorial.sc VMS_NOTES torev build.com

all:	$(name) p$(name) $(name)qref

$(name):$(PAR)  $(OBJS)
	$(CC) ${LDFLAGS} ${OBJS} ${LIB} -o $(name)

# Alternative link for MS-DOS
#$(name):	$(OBJS)
#	link ${LDFLAGS} ${OBJS},$(name),,${LIB};

gram.c:	gram.y
	$(YACC) -d gram.y
	mv $(YTAB).c gram.c

$(YTAB).h:	gram.y

p$(name):	psc.c pvmtbl.o pxmalloc.o
	$(CC) $(CFLAGS) ${LDFLAGS} -o p$(name) psc.c pvmtbl.o pxmalloc.o ${PSCLIB}

# Alternative link for MS-DOS (NB: MSC 5.1 has no getopt.c)
#p$(name):	psc.o pvmtbl.o pxmalloc.o getopt.o
#	link ${LDFLAGS} psc.o pvmtbl.o pxmalloc.o getopt.o,p$(name);

qhelp.c: help.c
	-rm -f qhelp.c
	${LN} help.c qhelp.c

$(name)qref:	qhelp.c sc.h
	$(CC) $(CFLAGS) $(LDFLAGS) -DQREF $(QREF_FMT) -DSCNAME=\"$(NAME)\" -o $(name)qref qhelp.c

# Alternative link for MS-DOS
#$(name)qref:	qhelp.c sc.h
#	$(CC) -AL -O -Foqhelp.o -c -DQREF -DSCNAME=\"$(name)\" qhelp.c
#	link ${LDFLAGS} qhelp.o,$(name)qref;

pvmtbl.c: vmtbl.c
	-rm -f pvmtbl.c
	${LN} vmtbl.c pvmtbl.c

pvmtbl.o: sc.h pvmtbl.c
	$(CC) ${CFLAGS} -c -DPSC pvmtbl.c

pxmalloc.c: xmalloc.c
	-rm -f pxmalloc.c
	${LN} xmalloc.c pxmalloc.c

# Objects

abbrev.o: abbrev.c sc.h
	$(CC) ${CFLAGS} ${DFLT_PAGER} -c abbrev.c

cmds.o: cmds.c sc.h
	$(CC) ${CFLAGS} ${DOBACKUPS} ${CRYPT} -c cmds.c

color.o: color.c sc.h

crypt.o: crypt.c sc.h
	$(CC) ${CFLAGS} ${CRYPT} ${DOBACKUPS} -c crypt.c

format.o: format.c

frame.o: frame.c sc.h

gram.o:	sc.h $(YTAB).h gram.c
	$(CC) ${CFLAGS} ${USELOCALE} -c gram.c
	sed < gram.y > experres.h -f eres.sed

=== debian/changelog ===
sc (7.16-5) UNRELEASED; urgency=medium

  * Migrate repository from alioth to salsa.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 27 May 2022 20:45:34 +0100

sc (7.16-4) unstable; urgency=low

  * debian/patches/function_definitions
    + use correct function signature instead of relying on implied
      one which used wrong number of parameters.
      This was found by Michael Tautschnig. (closes: #748220)
    + move most of the function declarations from sc.c into sc.h
    + is_cleared flag is now a macro in standard curses.h - to prevent
      redefinitions, prepend sc's flag usage with flag_

  * debian/patches/Upstream-changes-from-old-versions
    + contains all patches to upstream changes as one-big-diff. All of the
      changes should be self-explanatory (variable initialization, always return
      value from a function, etc.)
    + adding this quilt patch fixes FTBFS bug introduced by "new" behaviour
      to dpkg-source (closes: #643269). Yes, it's been a while since this
      package was updated.

  * debian/patches/use_varadic_macro
    + use variadic macros instead allowing us to silence "unused
      calculation results" warnings

  * debian/patches/call_function_not_take_its_address
    + call a function and use its return value instead of taking its
      address which is always true.

 -- Adam Majer <adamm@zombino.com>  Sun, 18 May 2014 14:28:50 -0500

sc (7.16-3) unstable; urgency=low

  * Changed maintainer to the new email address, recursively.
  * Fixed old changelog entries' bug closing method
  * Add patches supplied by Carsten Hey
    + Stop compressing tutorial.sc file (closes: #514777)
    + Use default colors (closes: #514775)
  * Bump Standards to 3.8.4.
  * Bump dependency of debhelper.

 -- Adam Majer <adamm@zombino.com>  Mon, 03 May 2010 15:52:17 -0500

sc (7.16-2) unstable; urgency=low

  * New maintainer (closes: #260000)
  * Fixed the code to remove most of the warnings during compile.
  * No longer tries to "redefine" malloc (closes: #259840)
  * debian/rules now uses debhelper

 -- Adam Majer <adamm@zombino.com>  Mon, 19 Jul 2004 14:24:48 -0500

sc (7.16-1) unstable; urgency=low

  * New upstream version.  (closes: Bug#131782, Bug#169590)
  * Doesn't use '#' as backup character.  (closes: Bug#127612)
  * Help page index fixed.  (closes: Bug#115456)
  * Tutorial file location corrected in man page.  (closes: Bug#115454)

 -- Chad Miller <cmiller@debian.org>  Tue, 19 Nov 2002 14:11:52 -0500

sc (7.13-2) unstable; urgency=low

  * Fixed spelling error in package description.

 -- Chad Miller <cmiller@debian.org>  Tue, 18 Dec 2001 14:22:47 +0000

sc (7.13-1) unstable; urgency=low

  * New upstream version; many bugfixes.  (closes: Bug#114473)

 -- Chad Miller <cmiller@debian.org>  Thu,  4 Oct 2001 19:54:46 +0000

sc (6.21-12) unstable; urgency=low

  * Installed 'tutorial.sc' in doc directory.  (closes: Bug:85546)

 -- Chad Miller <cmiller@debian.org>  Sat, 17 Mar 2001 15:03:21 -0500

sc (6.21-11) unstable; urgency=low

  * Maintainer change. (closes: Bug#68149)
  * Put manpages under /usr/share/man, as recent policy says.
  * Added to CFLAGS, to prevent ``still changing'' bug on some architectures.
    (closes: Bug#50986)

 -- Chad Miller <cmiller@debian.org>  Mon,  8 Jan 2001 15:20:02 -0500

sc (6.21-10) unstable; urgency=low

  * Added support for cursor keys, thanks to D. J. Raymond
    <raymond@kestrel.nmt.edu>

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Sun,  2 Jan 2000 17:35:34 +0100

sc (6.21-9) unstable; urgency=low

  * Corrected manpage creation (closes: Bug#48133)

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Fri, 29 Oct 1999 00:32:30 +0200

sc (6.21-8) frozen unstable; urgency=low

  * Removed external declaration for strcpy() and strcat() from format.c
    and included <string.h> instead. (closes: Bug#29540)

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Tue, 17 Nov 1998 11:19:50 +0100

sc (6.21-7) unstable; urgency=low

  * Re-compiled against ncurses4

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Fri, 30 Oct 1998 11:14:48 +0100

sc (6.21-6) unstable; urgency=low

  * Applied y2k patch from L J Bayuk <lbayuk@mindspring.com>.  Thanks to
    Ray for forwarding.

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Fri, 23 Oct 1998 19:21:05 +0200

sc (6.21-5) unstable; urgency=low

  * Undebhelpering it
  * Recompiled against ncurses3.4 to make it work with that lib (closes:
    Bug#25513, Bug#23241)
  * This works together with the current ncurses package

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Sun,  6 Sep 1998 22:22:47 +0000

sc (6.21-4) unstable; urgency=high

  * Recompiled against ncurses3.4 to make it work with that lib (closes:
    Bug#22616)
  * Added Conflicts: ncurses3.4 (<<1.9.9g-8.2)

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Tue, 19 May 1998 10:30:44 +0200

sc (6.21-3) frozen unstable; urgency=low

  * Corrected sc.1 manpage (closes: Bug#20915)
  * Removed dh_du
  * Added scqref.1 undocumented manpage link

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Sat, 11 Apr 1998 04:45:23 +0200

sc (6.21-2) unstable; urgency=low

  * Removed dependency to regex (closes: Bug#20079)
  * Little code clean ups in pvmtbl.c

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Mon, 23 Mar 1998 01:56:31 +0100

sc (6.21-1) unstable; urgency=low

  * First release
  * Removed references to initkbd(), resetkbd() and kbd_again()
  * Changed nmgetch() to getch()

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Thu, 12 Mar 1998 02:58:48 +0100

=== debian/control ===
Source: sc
Section: math
Priority: optional
Build-Depends: libncurses5-dev, bison, debhelper (>>7)
Maintainer: Adam Majer <adamm@zombino.com>
Standards-Version: 3.8.4
Vcs-Browser: https://salsa.debian.org/debian/sc
Vcs-Git: https://salsa.debian.org/debian/sc.git

Package: sc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Text-based spreadsheet with VI-like keybindings
 "Spreadsheet Calculator" is a much modified version of the public-
 domain spread sheet sc, which was posted to Usenet several years ago
 by Mark Weiser as vc, originally by James Gosling. It is based on
 rectangular table much like a financial spreadsheet.
 .
 Its keybindings are familiar to users of 'vi', and it has most
 features that a pure spreadsheet would, but lacks things like
 graphing and saving in foreign formats.  It's very stable and quite
 easy to use once you've put a little effort into learning it.
